#pragma once

#include <graph/server/spec.h>
#include <qabstractseries.h>
#include <QChart>
#include <QChartView>
#include <QLineSeries>
#include <QListWidgetItem>
#include <QValueAxis>

namespace Graph::GUI {
class ChartWidget : public QListWidgetItem {
 public:
  ChartWidget(QWidget* parent = nullptr, const chart_spec_t& spec = chart_spec_t());
  ~ChartWidget();

  QChartView* getView() const { return view; }
  QChart* getChart() const { return chart; }
  QList<QAbstractSeries*> getSeries() const { return chart->series(); }

 private:
  QChartView* view;
  QChart* chart;
  QValueAxis *x, *y;
};
} // namespace Graph::GUI
