#pragma once

#include <graph/plugins/plugin.h>
#include <QAbstractListModel>
#include <string>

namespace Graph {

class Plugin {
 private:
  plugin_t* plugin;
  const std::string path;
  const void* handle;

 public:
  Plugin(const std::string& path);
  ~Plugin();

  bool init(update_callback_t callback);

  const std::string& get_path() const { return this->path; }
};

class PluginModel : public QAbstractListModel {
  Q_OBJECT
 public:
  PluginModel(QObject* parent) : QAbstractListModel(parent) {}
  ~PluginModel();

  int rowCount(const QModelIndex& parent = QModelIndex()) const override;
  QVariant data(const QModelIndex& index, int role) const override;

  void add(Plugin* plugin);
  void remove(int index);

 private:
  QList<Plugin*> plugins;
};
} // namespace Graph
