#include <graph/server/gui/chart/chart.h>
#include <qsizepolicy.h>
#include <iostream>

namespace Graph::GUI {
ChartWidget::ChartWidget(QWidget* parent, const chart_spec_t& spec) : QListWidgetItem() {
  view = new QChartView(parent);
  chart = new QChart();

  // chart
  if (spec.legend)
    chart->legend()->show();
  else
    chart->legend()->hide();

  chart->setTitle(spec.title);

  // axis
  x = new QValueAxis();
  y = new QValueAxis();

  if (!spec.axis.x.auto_limit)
    x->setRange(spec.axis.x.min, spec.axis.x.max);
  if (!spec.axis.y.auto_limit)
    y->setRange(spec.axis.y.min, spec.axis.y.max);

  x->setTitleText(spec.axis.x.label);
  y->setTitleText(spec.axis.y.label);

  chart->addAxis(x, Qt::AlignBottom);
  chart->addAxis(y, Qt::AlignLeft);

  view->setChart(chart);
  view->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
  setSizeHint(view->sizeHint()*2);
}

ChartWidget::~ChartWidget() {
  // delete view;
  // delete chart;
  // delete x;
  // delete y;
}
} // namespace Graph::GUI